<template>
    <div>
        <loading :loading="loading"></loading>
        <popup-ad></popup-ad>
        <div class="flex">
            <div class="w-0 sm:w-0 md:w-1/6"></div>
            <div class="w-full sm:w-full md:w-5/6 flex flex-col justify-center">
                <div
                    class="w-full flex flex-col sm:flex-col md:flex-row justify-center items-center"
                >
                    <div class="w-10/12 sm:w-10/12 md:w-2/5">
                        <avatar :vestCapacity="capacity.vest" :backpackCapacity="capacity.backpack"></avatar>
                    </div>
                    <div class="w-0 sm:w-0 md:w-0"></div>
                    <div class="w-10/12 sm:w-10/12 md:w-3/5">
                        <chart :capacity="capacity" :selection="weights"></chart>
                    </div>
                </div>
                <div class="my-10">
                    <carousel></carousel>
                </div>
                <transition
                    mode="out-in"
                    v-on:before-enter="beforeEnter"
                    v-on:enter="enter"
                    v-on:leave="leave"
                    v-bind:css="false"
                >
                    <router-view
                        :existingTotalWeight="totalWeight"
                        :existingTotalCapacity="totalCapacity"
                        :existing="weights"
                        :existingCapacity="capacity"
                        @output="handleOutput"
                    ></router-view>
                </transition>
                <attributions></attributions>
            </div>
            <div class="w-0 sm:w-0 md:w-1/6"></div>
        </div>
        <app-footer></app-footer>
    </div>
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'
import { Action, State } from 'vuex-class'
import Carousel from './components/Carousel.vue'
import Attributions from './components/Attributions.vue'
import Chart from './components/Chart.vue'
import Avatar from './components/Avatar.vue'
import Loading from '@/app/shared/Loading.vue'
import PopupAd from '@/app/Sales/Ads/PopupAd.vue'
import AppFooter from '@/app/Home/Footer.vue'
import anime from 'animejs'
import * as _ from 'lodash'
import { IUserState } from '@/app/User/types/user/user'
import { IWeight } from '@/app/User/types/user/weight'
import { ISelectionState } from '../User/types/selection/selection'
import {
    ICategoriesState,
    IItem as INativeItem,
} from './categories/store/types'

interface IItem {
    name: string
    number: number
    unitWeight: number
    weight: number
}

interface Weights {
    [key: string]: any
    barrel?: IItem[]
    scopes?: IItem[]
    stocks?: IItem[]
    muzzle?: IItem[]
    throwables?: IItem[]
    bullets?: IItem[]
}

interface Capacity {
    [key: string]: any
    body?: number
    belt?: number
    vest?: number
    backpack?: number
}

@Component({
    components: {
        Carousel,
        Chart,
        Avatar,
        Attributions,
        Loading,
        PopupAd,
        AppFooter,
    },
})
export default class App extends Vue {
    @State('Selection') SELECTION_STATE: ISelectionState

    @State('Categories') CATEGORIES_STATE: ICategoriesState

    @Action('getURLS', { namespace: 'URLS' })
    getURLS: Function

    @Action('getOfflineSelection', { namespace: 'Selection' })
    getOfflineSelection: Function

    @Action('saveUserSelection', { namespace: 'Selection' })
    SAVE_USER_SELECTION: (payload: {
        capacity: Capacity
        weights: Weights
    }) => Promise<void>

    created() {
        this.$set(this.$data, 'capacity', this.defaultCapacity)
        this.init()
    }

    //data
    loading: boolean = false

    animationDefaults = {
        duration: 400,
        easing: 'cubicBezier(0.4, 0.0, 0.2, 1)',
    }

    defaultCapacity: Capacity = {
        body: 20,
        belt: 50,
        vest: 0,
        backpack: 0,
    }

    weights: Weights | null = null

    capacity: Capacity | null = null

    // Computed
    get totalWeight() {
        if (this.weights !== null) {
            let totalWeight = 0
            for (const iterator of Object.entries(this.weights)) {
                iterator[1].forEach(
                    (item: IItem) => (totalWeight += item.weight)
                )
            }
            return totalWeight
        }
        return 0
    }

    get totalCapacity() {
        if (this.capacity !== null) {
            let totalCapacity = 0
            for (const iterator of Object.entries(this.capacity)) {
                totalCapacity += iterator[1]
            }
            return totalCapacity
        }
        return 0
    }

    // methods
    async init() {
        this.loading = true
        try {
            await this.getURLS()
            await this.getOfflineSelection()
            //Update Capacity & Weights
            if (this.SELECTION_STATE.selection === undefined) {
                this.loading = false
                return
            }
            // Update Capacity
            if (this.SELECTION_STATE.selection.capacity === undefined) {
                this.loading = false
                return
            }
            const capacity = this.SELECTION_STATE.selection.capacity
            if (Object.entries(capacity).length > 0)
                this.$set(this.$data, 'capacity', capacity)

            // Update Weights
            if (this.SELECTION_STATE.selection.weights === undefined) {
                this.loading = false
                return
            }

            const weights = this.SELECTION_STATE.selection.weights
            const newWeights: { [key: string]: Array<IItem> } = {}

            for (const category in weights) {
                if (weights.hasOwnProperty(category)) {
                    const weightArr: IWeight[] = weights[category]
                    weightArr.forEach(weight => {
                        if (newWeights[weight.category] === undefined) {
                            newWeights[weight.category] = []
                        }
                        const categoryArr = this.CATEGORIES_STATE.categories[
                            category
                        ] as INativeItem[]
                        const [nativeCategory] = categoryArr.filter(
                            item => item.name === weight.name
                        )
                        const newWeight: IItem = {
                            name: weight.name,
                            number: weight.number,
                            unitWeight: nativeCategory.weight,
                            weight: nativeCategory.weight * weight.number,
                        }
                        newWeights[weight.category].push(newWeight)
                    })
                }
            }
            this.$set(this.$data, 'weights', newWeights)

            this.loading = false
        } catch (error) {
            console.log(error)
            this.loading = false
        }
    }

    handleOutput(output: any): void {
        const capacityItems = ['vest', 'backpack']
        const [key] = Object.keys(output)
        if (capacityItems.includes(key)) {
            if (this.capacity === null) this.capacity = {}
            this.$set(this.capacity, key, output[key].capacity)
            this.saveSelection()
        } else {
            const tempArr = []
            tempArr.push(output[key])
            if (this.weights === null) this.weights = {}
            if (this.weights[key] === undefined)
                this.$set(this.weights, key, [])
            _.remove(
                this.weights[key],
                (item: IItem) => item.name === output[key].name
            )
            this.$set(this.weights, key, [...this.weights[key], ...tempArr])
            this.saveSelection()
        }
    }

    saveSelection(): void {
        if (this.capacity === null || this.weights === null) return
        const payload = {
            capacity: this.capacity,
            weights: this.weights,
        }
        this.SAVE_USER_SELECTION(payload)
    }

    // Animation
    beforeEnter(el: HTMLElement) {
        el.style.opacity = '0'
        el.style.transform = 'translateX(-100px)'
    }

    enter(el: HTMLElement, done: Function) {
        anime({
            targets: el,
            opacity: 1,
            translateX: 0,
            ...this.animationDefaults,
            complete() {
                setTimeout(() => {
                    done()
                }, 100)
            },
        })
    }

    leave(el: HTMLElement, done: Function) {
        anime({
            targets: el,
            opacity: 0,
            translateX: 100,
            ...this.animationDefaults,
            complete() {
                setTimeout(() => {
                    done()
                }, 100)
            },
        })
    }
}
</script>
